/**
 * Visualizador da simulao.
 * 
 * @author Flavio Regis de Arruda.
 * @version 1.0
 */
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.Math.*;
import java.util.zip.*;
import java.util.*;

public class Cronometer extends SimulatorComponent{

    String msg;
    private final Color BACKGROUND = Color.black;
    private final Color FOREGROUND = Color.white;
    private int width;
    private int height;

    private int pulses=0;

    public int ARRIVAL=9;
    public int SERVICE=10;
    public Graphics g;

    public Cronometer(){
	pulses=0;
	setBackground(BACKGROUND);
	setForeground(FOREGROUND);
    }

    public void pulse(){
	pulses++;
	paint(g);
    }

    public void setGraphics(Graphics g){
	this.g = g;
    }

    public void paint(Graphics g){
	width = getSize().width;
	height = getSize().height;
	
	/* Paint de background */
	g.setColor(getBackground());
	g.fillRect(getX(), getY(), (int)Math.floor(0.9*width), (int)Math.floor(0.9*height));
	g.setColor(Color.red);
	g.drawString(" "+pulses+" s", (int)Math.floor(0.05*width)+getX(), (int)Math.floor(0.5*height)+getY());      
    }


    public void update(Graphics g){
	paint(g);
    }

}//end of class cronometer.
