import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;

public class Process extends SimulatorComponent{
    int width;
    int height;
    public static final Color BACKGROUND = Color.gray;
    public static final Color FOREGROUND = Color.white;
    private static int PID=0;
    int time;
    int pid;
    private Graphics g;

    public Process(){
	time=0;
	setBackground(BACKGROUND);
	setForeground(FOREGROUND);
	PID++;
	pid = PID;
    }

    public Process(int time){
	setBackground(BACKGROUND);
	setForeground(FOREGROUND);
	this.time = time;
	PID++;
	pid = PID;
    }

    public int getTime(){
	return this.time;
    }

    public void setTime(int time){
	if(time>0)
	    this.time = time;
	else
	    this.time=0;
    }

    public int getPid(){
	return pid;
    }

    public void paint(Graphics g){
	//System.out.println("Process.paint() com time="+time);
	width = getSize().width;
	height = getSize().height;
	
	// Draw the process.
	g.setColor(getBackground());
	g.fillRect(getX(), getY(), width , height);

	// Draw the remaining service time of the process.
	g.setColor(getForeground());
	g.drawString(""+time+"", getX()+ width/2, getY() + 3*height/4 );
	// Draw the PID.
	g.setColor(Color.yellow);
	g.drawString(""+pid+"", getX() /*+ width/2*/, getY() + height/2 );
    }

    public void update(Graphics g){
	paint(g);
    }

    public void setGraphics(Graphics g){
	this.g = g;
    }


}// end of class Process.
