import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;

public class Processor extends SimulatorComponent{
    int width;
    int height;
    private final Color BACKGROUND = Color.blue;
    private final Color FOREGROUND = Color.red;

    Process process;
    Queue   queue;

    public static int quantum;
    long pulses;
    Graphics g;

    public Processor(){
	process = null;
	pulses=0;
	quantum=3;
    }

    public void setGraphics(Graphics g){
	this.g = g;
    }

    public static void setQuantum(int q){
	quantum = q;
    }
    public void pulse(){
	pulses++;
	//System.out.println("Processor:pulse()");
	if(process !=null){
	    process.setTime(process.getTime()-1);
	    process.paint(g);
	}
	if(pulses>=quantum){
	    System.out.println("Processor: Context switch");
	    pulses=0;
	    Process proc;
	    if(queue.isClear()==false)
		proc = queue.get();
	    else
		return;
	    if(process != null){  //Se processador tem algum processo em andamento...
		//process.setTime(process.getTime()-quantum);
		if(process.getTime() <= 0)
		    process=null;
		else{
		    if(g==null)
			System.out.println("Processor ERROR: g is null! 1");
		    else{
			process.paint(g);
		    }
		}
	    }

	    queue.insert(process); //Devolve processo pra Fila de prontos.
	    process=proc; //CPU recebe o proximo processo da fila.
	    //Graphics g = getGraphics();
	    if(g==null)
		System.out.println("Processor ERROR: g is null! 2");
	    else{
		this.paint(g);
		process.paint(g);
		queue.paint(g);
	     }
	    
	}//end of if pulse.
	
    }//end of pulse.
    

    public void setQueue(Queue q){
	this.queue = q;
    }

    public void paint(Graphics g){
	width = getSize().width;
	height = getSize().height;
	/*
	  System.out.println("Processor.X="+getX()+" Processor.Y="+getY());
	  System.out.println("Processor.width="+width+" Processor.height="+height);
	*/
	// Draw Processor.
	g.setColor(BACKGROUND);
	g.fillRect(getX(),getY(), width, height);
	// Draw process space in cpu.
	if(process == null){
	    g.setColor(getBackground());
	    g.fillRect(getX()+ width/10,getY(), (width*80)/100, (height*50)/100);
	    g.setColor(FOREGROUND);
	}else{
	    process.setBackground(Process.BACKGROUND);
	    process.setLocation(getX()+ width/10,getY());
	    process.setSize((width*80)/100, (height*50)/100);
	    process.paint(g);
	}
	// Draw "CPU".
	String msg = "CPU";
	FontMetrics fm = getFontMetrics(getFont());
	g.drawString(msg, /*getX()+*/(int) Math.floor(1.1*width)  - fm.stringWidth(msg)/2 , getY() + (int)Math.floor(0.85*height));      
	
	
    }

    public void update(Graphics g){
	paint(g);
    }


}//end of class Processor.
