/*
 * Class Simulator.
 *     This class act as a Interface between the user and the other classes.
 *     It delivers configuration parameters to the engine of simulation and show the visualization to the user.
 * @author Flvio Rgis de Arruda
 * @date   28/11/2001.
 * @version 1.0
 */



import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;

public class Simulator extends Applet implements MouseListener, KeyListener {

    MediaTracker tracker;
    Graphics g;
    Viewer viewer;
    Panel npanel; //Panel at North
    Panel spanel; //Panel at South

    //private final int INITIAL_SIMULATION_AREA_X = 0;
    //private final int INITIAL_SIMULATION_AREA_Y = 99;

    private int height;
    private int width;
    private int cpuNumber;
    private boolean isFirst=true;
    private Thread vetThread[];
    private Clock vetClock[];

    Button bstart, bstop;
    TextField quantum, serv_time, interarr_time;
    public static boolean restart = false;
    /*
    public Simulator(){


    }
    */


    /* Applet methods */
    /* Initialize the applet */
    public void init() {
	/* Get parameters from html page */
	width = Integer.parseInt(getParameter("width"));
	height = Integer.parseInt( getParameter("height"));
	cpuNumber = Integer.parseInt( getParameter("cpuNumber"));
	vetThread = new Thread[cpuNumber];
	vetClock = new Clock[cpuNumber];

	this.setLayout(new BorderLayout());
     
	viewer = new Viewer();
	viewer.setLayout(new GridLayout(2, 2));
	
	for(int i=0; i < cpuNumber; i++){
	    Computer c = new Computer("Computer "+(i+1));
	    Clock clock = new Clock();
	    vetClock[i]=clock;
	    Processor p = new Processor();
	    c.setProcessor(p);
	    c.setClock(clock); clock.setComputer(c);
	    Thread tclock = new Thread(clock);
	    viewer.add(c);
	    vetThread[i]=tclock;
	}

	
	npanel = new Panel();
	npanel.setLayout(new GridLayout(2, 3));
	npanel.add(new Label("Interarrival", Label.CENTER));
	npanel.add(new Label("Service", Label.CENTER));
	npanel.add(new Label("Quantum", Label.CENTER));

	npanel.add("Center",interarr_time = new TextField("9"));
	npanel.add("Center",serv_time = new TextField("10"));
	npanel.add("Center",quantum = new TextField("3"));

	add(npanel, BorderLayout.NORTH);
	add(viewer, BorderLayout.CENTER);

	spanel = new Panel();
	spanel.setLayout(new GridLayout(1, 4));
	spanel.add(new Label(""));

	spanel.add(bstart = new Button("Start"));
	spanel.add(bstop = new Button("Pause"));
	spanel.add(new Label(""));
	add(spanel, BorderLayout.SOUTH);

	isFirst = true;
	// Add the MouseListener.
	addMouseListener(this);
   	
	paint(getGraphics());
	restart = true;
    }

    /* Paint the screen */ 
    public void paint(Graphics g){

	System.out.println("entrou em paint");
	if(isFirst){
	    for(int i=0; i< cpuNumber; i++){
		Thread t = vetThread[i];
		Clock c = vetClock[i];
		//c.paint(g); 
		t.start();  //Clock begin to work.
	    }
	    isFirst = false;
	    System.out.println("Terminou de inicializar clocks e threads!");
	}

	viewer.paint(g);
	
    }//end of paint.

    /* Update the screen */
    public void update(Graphics g){
	paint(g);

    }//end of update


    /* key tracking methods */
    public void keyTyped(KeyEvent e) {
	//Graphics g = getGraphics();
	//paint(g);
    }
    
    
    public void keyPressed(KeyEvent e) {
	
    }
    
    public void keyReleased(KeyEvent e) {
	
    }
    

    public boolean action(Event evt, Object arg)
     {
         if("Start".equals(arg))
         {
	     System.out.println("Clicou em bstart");
	     try{
		 int q  = Integer.parseInt(quantum.getText());
		 int ia = Integer.parseInt(interarr_time.getText());
		 int st = Integer.parseInt(serv_time.getText());
		 
		 Computer.setArrival(ia);
		 Computer.setQuantum(q);
		 Computer.setService(st);


	     }catch(Exception e){
		 System.out.println("Erro");
	     }
	     Clock.on();
	 }
	 else if("Pause".equals(arg)){
	     Clock.off();
	 }
	 return true;
     }

    /* mouse tracking methods */
    
    public void mouseClicked(MouseEvent e){

    } 

    public void mousePressed(MouseEvent e){
	
    } 
    public void mouseReleased(MouseEvent e){
	
    } 
    public void mouseEntered(MouseEvent e){
	
    } 
    public void mouseExited(MouseEvent e){
	
    } 

}//end of Applet.


